<template>
  <v-app dark>
    <v-navigation-drawer
      v-model="drawer"
      :mini-variant="miniVariant"
      fixed
      app
    >
      <p style="padding-top: 10px; text-align: center" v-if="auth.currentUser !== null">{{auth.currentUser.email}}</p>
      <v-list>
        <v-list-item
          v-for="(item, i) in items"
          :key="i"
          :to="item.to"
          router
          exact
        >
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title v-text="item.title"/>
          </v-list-item-content>
        </v-list-item>

        <v-list-item v-if="auth.currentUser !== null && rank === 'client' "
                     href="/cart"
        >
          <v-list-item-action>
            <v-badge
              :content="1"
              :value="1"
              color="green"
              overlap
            >
              <v-icon>
                mdi-cart-variant
              </v-icon>
            </v-badge>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Cart</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item v-if="auth.currentUser !== null && rank === 'Seller' "
                     href="/addProduct"
        >
          <v-list-item-action>
            <v-icon>{{ 'mdi-cart-variant' }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Add product</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-list-item v-if="auth.currentUser !== null"
                     @click="logout"
        >
          <v-list-item-action>
            <v-icon>{{ 'mdi-logout' }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>Logout</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>
    <v-app-bar
      :clipped-right="clipped"
      fixed
      app
    >
      <v-app-bar-nav-icon @click.stop="drawer = !drawer"/>

      <v-toolbar-title v-text="title"/>
      <v-spacer/>
      <v-btn
        color="warning"
        fab
        dark
        href="/login"
        v-if="auth.currentUser === null"
      >
        <v-icon>mdi-account-circle</v-icon>
        <p style="display: none">Login</p>
      </v-btn>

      <v-btn
        fab
        dark
        color="success"
        v-if="auth.currentUser !== null"
      >
        <v-icon>mdi-account-circle</v-icon>
      </v-btn>
    </v-app-bar>

    <v-main>
      <v-container>
        <Nuxt/>
      </v-container>
    </v-main>


    <v-footer
      :absolute="!fixed"
      app
    >
      <span>&copy; {{ new Date().getFullYear() }}</span>
    </v-footer>
  </v-app>
</template>

<script>
import { auth } from '~/firebase';
import { logout } from '~/clients/authClient';
import {checkRank} from '~/clients/dataClient';

export default {
  name: 'DefaultLayout',
  data() {
    return {
      clipped: false,
      drawer: false,
      fixed: false,
      items: [
        {
          icon: 'mdi-home',
          title: 'Homepage',
          to: '/'
        },
      ],
      miniVariant: false,
      right: true,
      rightDrawer: false,
      title: 'TopicShop',
      auth: auth,
      rank: ''
    };
  },
  methods: {
    async logout() {
      await logout()
        .then(
          this.$router.push('/')
        );
    }
  },
  created() {
    console.log(checkRank());
    if (typeof window !== 'undefined') {
      this.rank = localStorage.getItem('rank')
    }
    console.log(this.rank);
  }
}
</script>
